#include <linux/module.h> 
#include <linux/kernel.h> /* Pour KERN_INFO */
#include <linux/timer.h>

MODULE_DESCRIPTION("Hello World timer module");
MODULE_AUTHOR("Pierre Ficheux, Open Wide");
MODULE_LICENSE("GPL");

static int entier;
static struct timer_list timer;

module_param(entier, int, 0644);

static void timer_handler(unsigned long arg) 
{
  entier++;

  mod_timer(&timer, jiffies + HZ);
}

static int __init hello_timer_init(void)
{
  printk(KERN_INFO "Hello World timer\n");

 /* Initialise le timer */
  init_timer(&timer);
  timer.function = timer_handler;
  timer.data = 0;
  mod_timer(&timer, jiffies + HZ);
  
  return 0;
}

static void __exit hello_timer_exit(void)
{
  del_timer_sync(&timer);
  printk(KERN_INFO "Goodbye, cruel world!\n");
}

module_init(hello_timer_init);
module_exit(hello_timer_exit);
