#include <linux/module.h> 
#include <linux/kernel.h> /* Pour KERN_INFO */

MODULE_DESCRIPTION("Hello World module");
MODULE_AUTHOR("Pierre Ficheux, Open Wide");
MODULE_LICENSE("GPL");

#define MAX_STRING     10
#define MAX_TAB        16

/* Paramtres: entier, chane, tableau */
static int entier;
static char chaine[MAX_STRING];
static int tableau[MAX_TAB];

module_param(entier, int, 0644);
module_param_array(tableau, int, NULL, 0644);
module_param_string(chaine, chaine, sizeof(chaine), 0644);

MODULE_PARM_DESC(entier,"Un entier");
MODULE_PARM_DESC(chaine,"Une chane de caractres");
MODULE_PARM_DESC(tableau,"Un tableau d'entiers spars par des virgules");

static int __init hello3_init(void)
{
  register int i;

  printk(KERN_INFO "entier= %d chaine= %s\n", entier, chaine);

  for (i = 0  ; i < MAX_STRING ; i++) 
    printk(KERN_INFO "tableau[%d] = %d\n", i,  tableau[i]);

  return 0;
}

static void __exit hello3_exit(void)
{
	printk(KERN_INFO "Goodbye, cruel world!\n");
}

module_init(hello3_init);
module_exit(hello3_exit);
