#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/usb.h>

#define DRIVER_AUTHOR "Pierre Ficheux, pierre@ficheux.org"
#define DRIVER_DESC "Panic Button driver: version 0"

// Device definition
#define VENDOR_ID	0x1130
#define PRODUCT_ID	0x0202

/* Table of devices that work with this driver */
static struct usb_device_id id_table [] = {
	{ USB_DEVICE(VENDOR_ID, PRODUCT_ID) },
	{ },
};
MODULE_DEVICE_TABLE (usb, id_table);


static int panicb_probe (struct usb_interface *interface, const struct usb_device_id *id)
{
  printk (KERN_INFO "panicb_probe()\n");
  return 0;
}

static void panicb_disconnect(struct usb_interface *interface)
{
  printk (KERN_INFO "panicb_disconnect()\n");
}

static struct usb_driver panicb_driver = {
	.name =		"panicb",
	.probe =	panicb_probe,
	.disconnect =	panicb_disconnect,
	.id_table =	id_table,
};

static int __init usb_panicb_init(void)
{
  return usb_register(&panicb_driver);
}

static void __exit usb_panicb_exit(void)
{
  usb_deregister(&panicb_driver);
}


module_init (usb_panicb_init);
module_exit (usb_panicb_exit);

MODULE_AUTHOR(DRIVER_AUTHOR);
MODULE_DESCRIPTION(DRIVER_DESC);
MODULE_LICENSE("GPL");
